// -*- C++ -*-

//
//  Xlpq frontend to lpq,lprm,lpc
//
//  Copyright (C) 1996 Christoph Neerfeld
//  email:  Christoph.Neerfeld@mail.bonn.netsurf.de
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

extern "C" {
#include <forms.h>
#include "printer.h"
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <sys/time.h>
}

#include <iostream.h>
#include <fstream.h>
#include <String.h>

#include "config.h"

FD_fr1 *fr1;


void f_select (FL_OBJECT *ob, long user_data)
{
  f_update( (FL_OBJECT *) 0, 0);
}

void f_queue (FL_OBJECT *ob, long user_data)
{
  FILE *file;
  String progname;
  if(fl_get_button( ob))
    progname = (String) LPC + " enable " + (String) fl_get_choice_text(fr1->choice_1);
  else
    progname = (String) LPC + " disable " + (String) fl_get_choice_text(fr1->choice_1);
  file = popen((const char *) progname, "r");
  unsigned char c;
  String temp;
  while(c = fgetc(file))
    {
      if ( c >= 128) break;
      if ( c != '\n' )
	temp += c;
      else
	{
	  if(temp.contains("Privileged"))
	    {
	      fl_show_alert("Permission denied.", "This is a privileged command", \
			    "and you do not have permission to execute it.", 0);
	      pclose(file);
	      if(fl_get_button(ob))
		fl_set_button(ob, 0);
	      else
		fl_set_button(ob, 1);
	      return;
	    }
	  temp = "";
	}
    }
  pclose(file);
  f_update( (FL_OBJECT *) 0, 0);
  fl_select_browser_line(fr1->browser_1, 1);
}

void f_print (FL_OBJECT *ob, long user_data)
{
  FILE *file;
  String progname;
  if(fl_get_button( ob))
    progname = (String) LPC + " start " + (String) fl_get_choice_text(fr1->choice_1);
  else
    progname = (String) LPC + " stop " + (String) fl_get_choice_text(fr1->choice_1);
  file = popen((const char *) progname, "r");
  unsigned char c;
  String temp;
  while(c = fgetc(file))
    {
      if ( c >= 128) break;
      if ( c != '\n' )
	temp += c;
      else
	{
	  if(temp.contains("Privileged"))
	    {
	      fl_show_alert("Permission denied.", "This is a privileged command", \
			    "and you do not have permission to execute it.", 0);
	      pclose(file);
	      if(fl_get_button(ob))
		fl_set_button(ob, 0);
	      else
		fl_set_button(ob, 1);
	      return;
	    }
	  temp = "";
	}
    }
  pclose(file);
  f_update( (FL_OBJECT *) 0, 0);
  fl_select_browser_line(fr1->browser_1, 1);
}

void f_remove (FL_OBJECT *ob, long user_data)
{
  String words[3];
  int i = fl_get_browser(fr1->browser_1);
  if ( i == 0) return;
  String line = fl_get_browser_line(fr1->browser_1, i);
  split(line, words, 3, RXwhite);
  if(fl_show_question("", "Do you realy want to remove job Nr.", (const char*) words[2]))
    {
      String progname;
      progname = (String) "lprm -P " + (String) fl_get_choice_text(fr1->choice_1) + \
	" " +(String) words[2];
      system((const char *) progname);
      f_update( (FL_OBJECT *) 0, 0);
      fl_select_browser_line(fr1->browser_1, 1);
    }
}

void f_make_top (FL_OBJECT *ob, long user_data)
{
  FILE *file;
  String words[3];
  int i = fl_get_browser(fr1->browser_1);
  if ( i == 0) return;
  String line = fl_get_browser_line(fr1->browser_1, i);
  split(line, words, 3, RXwhite);
  if(fl_show_question("Do you realy want to move job Nr.", (const char*) words[2], \
     "on top of queue"))
    {
      String progname;
      progname = (String) LPC + " topq " + (String) fl_get_choice_text(fr1->choice_1) + \
	" " +(String) words[2];
      file = popen((const char *) progname, "r");
      unsigned char c;
      String temp;
      while(c = fgetc(file))
	{
	  if ( c >= 128) break;
	  if ( c != '\n' )
	    temp += c;
	  else
	    {
	      if(temp.contains("Privileged"))
		{
		  fl_show_alert("Permission denied.", "This is a privileged command", \
				"and you do not have permission to execute it.", 0);
		  pclose(file);
		  return;
		}
	      temp = "";
	    }
	}
      pclose(file);
      f_update( (FL_OBJECT *) 0, 0);
      fl_select_browser_line(fr1->browser_1, 1);
    }
}

void f_browser (FL_OBJECT *ob, long user_data)
{

}

void f_update (FL_OBJECT *ob, long user_data)
{
  FILE *file;
  String progname;
  progname = (String) "lpq -P " + (String) fl_get_choice_text(fr1->choice_1);
  file = popen((const char *) progname, "r");
  unsigned char c;
  String temp, label;
  label = "";
  short i=0;
  fl_clear_browser(fr1->browser_1);
  while(c = fgetc(file))
    {
      if ( c >= 128) break;
      if ( c != '\n' )
	temp += c;
      else
	{
	  if(temp.contains("Rank"))
	     { i = 1; temp = ""; continue; }
	  if(i == 0) 
	    {
	      label += temp + '\n';
	      fl_set_object_label(fr1->status, (const char*) label);
	    }
	  else
	    {
	      fl_add_browser_line(fr1->browser_1, (const char*) temp);
	    }
	  temp = "";
	}
    }
  pclose(file);
  // --- exec lpc
  progname = (String) LPC + " status " + (String) fl_get_choice_text(fr1->choice_1);
  file = popen((const char *) progname, "r");
  while(c = fgetc(file))
    {
      if ( c >= 128) break;
      if ( c != '\n' )
	temp += c;
      else
	{
	  if(temp.contains("queuing"))
	     { 
	       if(temp.contains("disabled"))
		 { fl_set_button(fr1->queuing, 0); }
	       else
		 { fl_set_button(fr1->queuing, 1); }
	       temp = ""; continue; 
	     }
	  else if (temp.contains("printing"))
	    { 
	       if(temp.contains("disabled"))
		 { fl_set_button(fr1->printing, 0); }
	       else
		 { fl_set_button(fr1->printing, 1); }
	       temp = ""; continue; 
	     }
	  temp = "";
	}
    }
  pclose(file);
  fl_select_browser_line(fr1->browser_1, 1);
  fl_redraw_object(fr1->status_frame);
  return;
}

void f_quit (FL_OBJECT *ob, long user_data)
{
  fl_finish();
  exit(0);
}

void f_timer ( int sig, void *data)
{
  f_update( (FL_OBJECT *) 0, 0);
  alarm(5);
}

void f_auto (FL_OBJECT *ob, long user_data)
{
  if(fl_get_button(ob))
    { fl_add_signal_callback(SIGALRM, f_timer, (void *) 0); alarm(5); }
  else
    { alarm (0); fl_remove_signal_callback(SIGALRM); }
}

void f_version (FL_OBJECT *ob, long user_data)
{
  fl_show_message("This is Xlpq Version 1.0.1 by Christoph Neerfeld",\
		  "This program is copyrighted, but you may distribute it",\
		  "under the terms of the GNU General Public Licence.");
}

main (int argc, char **argv)
{
  fl_initialize(&argc, argv, "Xlpq", 0, 0);

  String progname, choice;
  choice = (String) getenv("PRINTER");
  char c;
  while ( ( c = getopt (argc, argv, "hP:")) != -1)
    {
      switch (c)
        {
        case 'h':
          cout << "usage: xlpq [ [-P printername] file ]" << endl;
          exit(1);
        case 'P':
          choice = (String) optarg;
          break;
        case '?':
          break;
        default:
          exit (1);
        }
    }
  if ( optind < argc )
    {
      progname = (String) "lpr ";
      if ( choice != "" )
	{
	  progname += "-P " + choice + " ";
	}
      progname += (String) argv[optind];
      system((const char *) progname);
    }

  fr1 = create_form_fr1();
  fl_set_browser_fontsize(fr1->browser_1, 11);
  fl_set_browser_fontstyle(fr1->browser_1, FL_FIXED_STYLE);
  fl_set_goodies_font(FL_BOLD_STYLE,12);

  char inbuf[512];
  String temp, name;
  short empty_printcap = 1;
  ifstream printcap("/etc/printcap", ios::in);
  if( !printcap)
    {
      cout << "Sorry, can't open your printcap file." << endl;
      exit(1);
    }
  while (printcap.getline(inbuf, 512, '\n'))
    {
      if( inbuf[0] == '#' || inbuf[0] == 0) continue;
      temp = inbuf;
      name = temp.before(":");
      if( name.length() == 0 ) continue;
      if( name.contains("|") )
	name = name.before("|");
      while( name.length() != 0 && name[0] == ' ' )
	{
	  name.del(" ");
	}
      if(name.length() == 0) continue;
      while ( temp[temp.length()-1] == '\\')
	{
	  printcap.getline(inbuf, 512, '\n');
	  if( inbuf[0] == '#')
	    temp = "\\";
	  else
	    temp = inbuf;
	}
      if( name.length() != 0 )
	empty_printcap = 0;
      fl_addto_choice(fr1->choice_1, (const char*) name);
      if( name == choice)
	fl_set_choice_text(fr1->choice_1, (const char*) name);
    }
  printcap.close();
  if( empty_printcap )
    {
      cout << "Sorry, unable to parse your printcap." << endl;
      cout << "Please email your printcap to Christoph.Neerfeld@mail.bonn.netsurf.de" << endl;
      exit(1);
    }
  f_update( (FL_OBJECT *) 0, 0);
  fl_select_browser_line(fr1->browser_1, 1);
  fl_show_form(fr1->fr1, FL_PLACE_MOUSE, FL_FULLBORDER, "Xlpq");
  fl_set_object_bw(fr1->gr1, -3);
  //  fl_add_signal_callback(SIGALRM, f_timer, (void *) 0);
  //  alarm(10);
  fl_do_forms();
}  
